<?php

$WEB_PAGE = "YES"; // Change to "NO" to block access
$VSTREAM_PROXY = "OFF"; // "ON" For Proxy, "OFF" For Without proxy
$PLAYLIST_FORMAT = "ON"; // "ON" for JSON Playlist, "OFF" for M3U Playlist
$CDN_PROXY = "NO"; // "YES" FOR INCLUDE Cdn Proxy OR "NO" For disable CDN proxy
$REFER_SECURITY = "NO"; // Set to "YES" to require Referer, "NO" to allow access without Referer
$coderef = ""; //Referer Security,When you active VSTREAM_PROXY, it's work

//----------DO--NOT----EDIT---BELOW------//

$cacheDir = 'codtce_secured';
$cacheFile = $cacheDir . '/_cfcache';

// Ensure the directory exists
if (!is_dir($cacheDir)) {
    mkdir($cacheDir, 0777, true);
}

$htaccessFile = $cacheDir . '/.htaccess';
if (!file_exists($htaccessFile)) {
    @file_put_contents($htaccessFile, "deny from all");
}

//---T-H-I-S---S-C-R-P-I-T-------C-O-D-E-D-----B-Y----C-O-D-E-C-U-T-E-R------//

// Function to fetch new data for token
function fetchNewData($id) {
    $codcf = "https://apix.rabbitholebd.com/appv2/get/cfToken?base=streams.rabbitholebd.com&type=token&channel_id=$id";

    $headers = [
        "Content-Type: application/json",
        "X-Access-Token: ".getFetchedXToken(),
        "Current-Time: " . time() * 1000,
        "Hash: " . hash('sha256', uniqid()),
        "User-Agent: Rabbithole/3.8.1 (Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Mobile Safari/537.36)",
        "Device-Type: 2",
        "Accept-Encoding: gzip",
    ];

    $ch = curl_init($codcf);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);

    // Decompress if gzipped
    if (strpos($response, "\x1f\x8b\x08") === 0) {
        $response = gzdecode($response);
    }

    return $response;
}

// Function to save data to the cache file
function saveCache($cacheFile, $response) {
    $cacheData = [
        'timestamp' => time(),
        'response' => $response
    ];

    // Save the response and timestamp to the cache file
    file_put_contents($cacheFile, json_encode($cacheData));
}

// Fetch stream data for the given ID
function fetchStreamData($id) {
    $response = fetchNewData($id);
    saveCache($GLOBALS['cacheFile'], $response); // Save the response to cache

    // Decode the JSON response
    $data = json_decode($response, true);
    if ($data === null) {
        return "Error decoding JSON";
    }

    $outputData = [];
    parse_str($data['output'], $outputData);

    $uid = '4044782638326675'; // Manually set UID
    $country = $data['country'];

    // Fetch the channel URL
    $url = "https://apix.rabbitholebd.com/appv2/getFront/channel?channel_id=$id&country=BD&device_type=2";

    $headers = [
        "Content-Type: application/json",
        "x-access-token: ".getFetchedXToken(),
        "current-time: " . time() * 1000,
        "hash: " . hash('sha256', uniqid()),
        "User-Agent: Rabbithole/3.8.1 (Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Mobile Safari/537.36)",
        "device_type: 2",
        "accept-encoding: gzip"
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_ENCODING, "gzip");

    $response = curl_exec($ch);
    curl_close($ch);

    $data = json_decode($response, true);
    if (json_last_error() === JSON_ERROR_NONE) {
        if (isset($data['output']['current_channel']['base']) && isset($data['output']['current_channel']['identifier'])) {
            $base = $data['output']['current_channel']['base'];
            $identifier = $data['output']['current_channel']['identifier'];

            // Check if CDN_PROXY is enabled
            if ($GLOBALS['CDN_PROXY'] === "YES") {
                $base = "cdn-rabbitholebd-live.codecuterapi.workers.dev";  // Use CDN URL
            }

            $playUrl = "https://" . $base . "/live/" . $identifier . "/" . $identifier . "/index.m3u8";
            return $playUrl;
        }
    }
    return "Error: Base or Identifier not found in the response.";
}

// Fetch cookie data for the given ID
function fetchCookieData($id) {
    $response = fetchNewData($id);
    $data = json_decode($response, true);
    if ($data === null) {
        return "Error decoding JSON";
    }

    $outputData = [];
    parse_str($data['output'], $outputData);

    $uid = '4044782638326675'; // Manually set UID
    $country = $data['country'];

    // Return the cookie data
    return "CloudFront-Policy={$outputData['Policy']}; CloudFront-Signature={$outputData['Signature']}; CloudFront-Key-Pair-Id={$outputData['Key-Pair-Id']}; uid={$uid}; country={$country}";
}

//------------THIS---SCRIPT---CODED---BY--C-O-D-E-C-U-T-E-R------------//

include '_upstrmcod.php';

?>