<?php
session_start();

// Path to the credentials file
$secure_file_path = 'codtce_secured/_codsecured';

// Function to read credentials from the file
function get_credentials_from_file() {
    global $secure_file_path;

    if (file_exists($secure_file_path)) {
        $credentials = file_get_contents($secure_file_path);
        $lines = explode("\n", $credentials);
        
        $username = 'Codecuter';
        $password = 'rabi#890';

        foreach ($lines as $line) {
            if (strpos($line, 'username: ') === 0) {
                $username = trim(substr($line, strlen('username: ')));
            }
            if (strpos($line, 'password: ') === 0) {
                $password = trim(substr($line, strlen('password: ')));
            }
        }

        return ['username' => $username, 'password' => $password];
    }

    // If the file doesn't exist, create it with default credentials
    create_credentials_file();

    return ['username' => '', 'password' => ''];
}

// Function to create the credentials file with default username and password
function create_credentials_file() {
    global $secure_file_path;

    $default_username = 'Codecuter';
    $default_password = 'rabi#890';

    // Content for the credentials file
    $content = "username: $default_username\npassword: $default_password\n";

    // Write the content to the file
    file_put_contents($secure_file_path, $content);
}

$credentials = get_credentials_from_file();
$valid_username = $credentials['username'];
$valid_password = $credentials['password'];

$error = '';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_POST['login'])) {
        $username = $_POST['username'];
        $password = $_POST['password'];

        if ($username === $valid_username && $password === $valid_password) {
            $_SESSION['logged_in'] = true;
            header("Location: login.php");
            exit;
        } else {
            $error = "Invalid username or password.";
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>ADMIN LOGIN [RABBITHOLD] - POWERED BY CODECUTER</title>
    <style>
        /* Reset and Base Styles */
        * {
            margin: 0;
            padding: 0;
            box-sizing: border-box;
        }
        body {
            font-family: 'Poppins', sans-serif;
            background: linear-gradient(135deg, #1b2838, #17212b);
            height: 100vh;
            overflow: hidden;
            color: white;
        }

        /* Logo Styling */
        .logo-container {
            position: absolute;
            top: 0;
            left: 50%;
            transform: translateX(-50%);
            width: 100%;
            text-align: center;
            padding: 20px 0; /* Spacing for the top */
        }

        .logo-container img {
            width: 200px; /* Adjust size */
            height: auto; /* Maintain proportions */
        }

        /* Login Container Styles */
        .login-container {
            background: rgba(255, 255, 255, 0.15);
            backdrop-filter: blur(10px);
            border-radius: 20px;
            padding: 50px 30px 40px;
            width: 100%;
            max-width: 400px;
            text-align: center;
            box-shadow: 0 4px 30px rgba(0, 0, 0, 0.5);
            position: absolute;
            top: 100px; /* Adjust to move the panel below the logo */
            left: 50%;
            transform: translateX(-50%);
        }

        .login-container h2 {
            font-size: 26px;
            font-weight: bold;
            color: white;
            margin-bottom: 20px;
            text-transform: uppercase;
        }

        /* Input Fields */
        .input-wrapper {
            position: relative;
            margin-bottom: 20px;
        }

        .input-wrapper input {
            width: 100%;
            padding: 15px 20px;
            border: 2px solid rgba(255, 255, 255, 0.2);
            border-radius: 10px;
            font-size: 16px;
            background: transparent;
            color: white;
            outline: none;
        }

        .input-wrapper input::placeholder {
            color: rgba(255, 255, 255, 0.5);
        }

        /* Floating Label Effect */
        .input-wrapper label {
            position: absolute;
            top: 50%;
            left: 20px;
            transform: translateY(-50%);
            color: rgba(255, 255, 255, 0.5);
            transition: 0.3s;
            pointer-events: none;
        }

        .input-wrapper input:focus + label,
        .input-wrapper input:not(:placeholder-shown) + label {
            top: -10px;
            left: 15px;
            font-size: 12px;
            color: #9b59b6;
        }

        /* Button Styles */
        button {
            width: 100%;
            padding: 15px;
            background: linear-gradient(135deg, #6a11cb, #2575fc);
            border: none;
            border-radius: 10px;
            color: white;
            font-size: 16px;
            font-weight: bold;
            cursor: pointer;
            transition: all 0.3s;
        }

        button:hover {
            background: linear-gradient(135deg, #5a0c9c, #2067d1);
            transform: translateY(-2px);
        }

        /* Error Message */
        .error {
            color: #e74c3c;
            font-size: 14px;
            margin-bottom: 10px;
        }
    </style>
</head>
<body>
    <!-- Logo Container -->
    <div class="logo-container">
        <img src="https://i.postimg.cc/j2MWGXBJ/20250107-125253.png" alt="CODTC Logo">
    </div>
    
    <div class="login-container">
        <h2>Admin Login</h2>
        
        <?php if (!empty($error)): ?>
            <p class="error"><?php echo $error; ?></p>
        <?php endif; ?>

        <form method="POST">
            <div class="input-wrapper">
                <input type="text" name="username" placeholder=" " required>
                <label for="username">Username</label>
            </div>

            <div class="input-wrapper">
                <input type="password" name="password" placeholder=" " required>
                <label for="password">Password</label>
            </div>

            <button type="submit" name="login">Login</button>
        </form>
    </div>
</body>
</html>