<?php

include('_functions.php');

// Fetch live match data
$data = fetchLiveMatchData();

// Process the data
$processedData = processChannelData($data);

// Referer URL for streaming
$vstremref = "https://www.rabbitholebd.com";

// Function to fetch the full streaming URL
function fetchFullStreamUrl($id, $vstremref) {
    $streamingURL = fetchStreamData($id); // Fetch stream URL based on channelId
    $cfStreamToken = fetchCookieData($id); // Fetch cookie token based on channelId
    return $streamingURL;
}

// Output based on PLAYLIST_FORMAT
if ($PLAYLIST_FORMAT === "ON") {
    // JSON format
    header('Content-Type: application/json');
    $playlist = [];
    
    // Add live matches
    if (is_array($processedData['live']) && count($processedData['live']) > 0) {
        foreach ($processedData['live'] as $match) {
            $id = $match['channelId'];
            $playlist[] = [
                'name' => $match['name'],
                'link' => fetchFullStreamUrl($id, $vstremref),
                'logo' => $match['poster'],
                'origin' => $vstremref,
                'referrer' => $vstremref . '/',
                'userAgent' => $_SERVER['HTTP_USER_AGENT'],
                'cookie' => fetchCookieData($id),
                'coded-by' => 'Alex',
                'powered-by' => 'Codecuter'
            ];
        }
    }

    // Add upcoming matches
    if (is_array($processedData['upcoming']) && count($processedData['upcoming']) > 0) {
        foreach ($processedData['upcoming'] as $match) {
            $id = $match['channelId'];
            $playlist[] = [
                'name' => $match['name'],
                'link' => fetchFullStreamUrl($id, $vstremref),
                'logo' => $match['poster'],
                'origin' => $vstremref,
                'referrer' => $vstremref . '/',
                'userAgent' => $_SERVER['HTTP_USER_AGENT'],
                'cookie' => fetchCookieData($id),
                'coded-by' => 'Alex',
                'powered-by' => 'Codecuter'
            ];
        }
    }

    echo json_encode($playlist, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);
    exit;
} else {
    // M3U format
    header('Content-Type: audio/mpegurl');
    
    // Get the hosting domain and folder path
    $dh = $_SERVER['HTTP_HOST'];  // This will get the domain
    $path = dirname($_SERVER['PHP_SELF']);  // This will get the folder path

    echo "#EXTM3U\n";

    // Add live matches
    if (is_array($processedData['live']) && count($processedData['live']) > 0) {
        foreach ($processedData['live'] as $match) {
            $id = $match['channelId'];
            // Generate the M3U URL dynamically
            $m3uUrl = "http://$dh$path/vstream.m3u8?id=$id|Referer=".$coderef."";
            echo "#EXTINF:-1 tvg-logo=\"" . $match['poster'] . "\", " . $match['name'] . "\n";
            echo $m3uUrl . "\n";
        }
    }

    // Add upcoming matches
    if (is_array($processedData['upcoming']) && count($processedData['upcoming']) > 0) {
        foreach ($processedData['upcoming'] as $match) {
            $id = $match['channelId'];
            // Generate the M3U URL dynamically
            $m3uUrl = "http://$dh$path/vstream.m3u8?id=$id|Referer=".$coderef."";
            echo "#EXTINF:-1 tvg-logo=\"" . $match['poster'] . "\", " . $match['name'] . "\n";
            echo $m3uUrl . "\n";
        }
    }
}
?>